<template>
	<q-dialog v-model="userPrivForm" class="dialog">
		<q-card style="width: 500px;">
			<form>
				<div class="row">
					<q-card-section>
						<div class="text-h6">Privilege</div>
					</q-card-section>
					<q-space />
					<q-card-section>
						<q-btn round dense icon="close" v-close-popup />
					</q-card-section>
				</div>

				<q-card-section class="q-pt-none">
					<div>Set privilege to : {{ userName }}</div>
					<div class="q-gutter-y-md" style="max-width: 100%;">
						<q-option-group
							v-model="panel"
							inline
							:options="[
								{
									label: 'User management',
									value: 'userM',
								},
								{
									label: 'User Information',
									value: 'alarms',
								},
								{ label: 'Todo', value: 'movies' },
							]"
						/>

						<q-tab-panels
							v-model="panel"
							animated
							class="shadow-2 rounded-borders"
						>
							<q-tab-panel name="userM">
								<form>
									<div class="row">
										<div>
											<q-checkbox
												v-model="accessUm"
												label="Access"
											/>
											<q-checkbox
												v-model="modifyUm"
												label="Modify"
											/>
										</div>

										<q-space />
										<div>
											<q-btn
												label="Save"
												color="primary"
												type="button"
												@click="userMngmntPrivSave"
											/>
										</div>
									</div>
								</form>
							</q-tab-panel>

							<q-tab-panel name="alarms">
								<form>
									<div class="row">
										<div>
											<q-checkbox
												v-model="accessUi"
												label="Access"
											/>
											<q-checkbox
												v-model="addUi"
												label="Add"
											/>
											<q-checkbox
												v-model="updateUi"
												label="Update"
											/>
											<q-checkbox
												v-model="deleteUi"
												label="Delete"
											/>
										</div>

										<q-space />
										<div>
											<q-btn
												label="Save"
												color="primary"
												type="button"
												@click="userInfoPrivSave"
											/>
										</div>
									</div>
								</form>
							</q-tab-panel>

							<q-tab-panel name="movies">
								<form>
									<div class="row">
										<div>
											<q-checkbox
												v-model="accessT"
												label="Access"
											/>
											<q-checkbox
												v-model="addT"
												label="Add"
											/>
											<q-checkbox
												v-model="updateT"
												label="Update"
											/>
											<q-checkbox
												v-model="deleteT"
												label="Delete"
											/>
										</div>

										<q-space />
										<div>
											<q-btn
												label="Save"
												color="primary"
												type="button"
												@click="userTodoPrivSave"
											/>
										</div>
									</div>
								</form>
							</q-tab-panel>
						</q-tab-panels>
						<q-dialog
							v-model="alertSuccess"
							persistent
							transition-show="scale"
							transition-hide="scale"
						>
							<q-card
								class="bg-green-9 text-white"
								style="width: 300px;"
							>
								<q-card-section>
									<div class="text-h6">Success</div>
								</q-card-section>

								<q-card-section class="q-pt-none">
									Privilege has been set.
								</q-card-section>

								<q-card-actions
									align="right"
									class="bg-white text-teal"
								>
									<q-btn flat label="OK" v-close-popup />
								</q-card-actions>
							</q-card>
						</q-dialog>
					</div>
				</q-card-section>
			</form>
		</q-card>
	</q-dialog>
</template>

<script>
import { mapGetters } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
			panel: "userM",
			access: null,
			modify: null,
			add: null,
			update: null,
			delete: null,

			// checkbox names
			accessUm: false,
			modifyUm: false,

			accessUi: false,
			addUi: false,
			updateUi: false,
			deleteUi: false,

			accessT: false,
			addT: false,
			updateT: false,
			deleteT: false,
		};
	},
	methods: {
		userMngmntPrivSave() {
			if (this.accessUm) {
				this.access = "true";
			} else {
				this.access = "false";
			}
			if (this.modifyUm) {
				this.modify = "true";
			} else {
				this.modify = "false";
			}
			this.$axios.post(
				this.host + "/src/php/actions/user-management-priv.php",
				{
					userId: this.userId,
					access: this.access,
					modify: this.modify,
				}
			);
			this.alertSuccess = true;
		},
		userInfoPrivSave() {
			if (this.accessUi) {
				this.access = "true";
			} else {
				this.access = "false";
			}
			if (this.addUi) {
				this.add = "true";
			} else {
				this.add = "false";
			}
			if (this.updateUi) {
				this.update = "true";
			} else {
				this.update = "false";
			}
			if (this.deleteUi) {
				this.delete = "true";
			} else {
				this.delete = "false";
			}
			this.$axios.post(
				this.host + "/src/php/actions/user-information-priv.php",
				{
					userId: this.userId,
					access: this.access,
					add: this.add,
					update: this.update,
					delete: this.delete,
				}
			);
			this.alertSuccess = true;
		},
		userTodoPrivSave() {
			if (this.accessT) {
				this.access = "true";
			} else {
				this.access = "false";
			}
			if (this.addT) {
				this.add = "true";
			} else {
				this.add = "false";
			}
			if (this.updateT) {
				this.update = "true";
			} else {
				this.update = "false";
			}
			if (this.deleteT) {
				this.delete = "true";
			} else {
				this.delete = "false";
			}
			this.$axios.post(this.host + "/src/php/actions/todo-priv.php", {
				userId: this.userId,
				access: this.access,
				add: this.add,
				update: this.update,
				delete: this.delete,
			});
			this.alertSuccess = true;
		},
		getUserMngPriv() {
			this.$axios
				.get(
					this.host +
						"/src/php/actions/user-management-priv.php?userId=" +
						this.userId
				)
				.then((response) => {
					console.log(response.data);
				});
		},
		test() {
			if (this.userPriv) {
				console.log("test");
			}
		},
	},
	computed: {
		...mapGetters({
			userPriv: "showcase/userPriv",
			userId: "showcase/userId",
			userName: "showcase/userName",
		}),
		userPrivForm: {
			get() {
				return this.userPriv;
			},
			set(val) {
				this.$store.commit("showcase/hideUserPrivPwdForm", val);
			},
		},
	},
	watch: {
		userPriv() {
			this.$axios
				.get(
					this.host +
						"/src/php/actions/user-management-priv.php?userId=" +
						this.userId
				)
				.then((response) => {
					this.accessUm = JSON.parse(response.data.umAccess);
					this.modifyUm = JSON.parse(response.data.umModify);
				});
			this.$axios
				.get(
					this.host +
						"/src/php/actions/user-information-priv.php?userId=" +
						this.userId
				)
				.then((response) => {
					if (response.data.uiAccess === null) {
						this.accessUi = false;
					} else {
						this.accessUi = JSON.parse(response.data.uiAccess);
					}
					if (response.data.uiAdd === null) {
						this.addUi = false;
					} else {
						this.addUi = JSON.parse(response.data.uiAdd);
					}
					if (response.data.uiEdit === null) {
						this.updateUi = false;
					} else {
						this.updateUi = JSON.parse(response.data.uiEdit);
					}
					if (response.data.uiDelete === null) {
						this.deleteUi = false;
					} else {
						this.deleteUi = JSON.parse(response.data.uiDelete);
					}
				});
			this.$axios
				.get(
					this.host +
						"/src/php/actions/todo-priv.php?userId=" +
						this.userId
				)
				.then((response) => {
					if (response.data.tdAccess === null) {
						this.accessT = false;
					} else {
						this.accessT = JSON.parse(response.data.tdAccess);
					}
					if (response.data.tdAdd === null) {
						this.addT = false;
					} else {
						this.addT = JSON.parse(response.data.tdAdd);
					}
					if (response.data.tdEdit === null) {
						this.updateT = false;
					} else {
						this.updateT = JSON.parse(response.data.tdEdit);
					}
					if (response.data.tdDelete === null) {
						this.deleteT = false;
					} else {
						this.deleteT = JSON.parse(response.data.tdDelete);
					}
				});
		},
	},
	created() {},
};
</script>
